import Sudoku, gexf;

SudokuEdgesPrep := Sudoku.Functions.Relationships();
SudokuBlocks := Sudoku.Functions.Blocks();
stacksize := 3;
blockrows := 9;
bandsize := 3;

NodesPrep := dedup(sort(project(SudokuBlocks, transform(Sudoku.Functions.rBoxBlocks, self.bandnum := (((unsigned)(left.blocknum-1) / (stacksize * blockrows))), self.stacknum := (((integer)(left.blocknum-1)/ bandsize)%stacksize+1),
		                                 self.boxnum := (self.bandnum*stacksize) + self.stacknum, self.blocknum := left.blocknum)), blocknum), blocknum);

SudokuEdges := project(SudokuEdgesPrep, transform(gexf.CreateGraph.graph_edge_rec, self.source := left.fromblocknum, self.target := left.toblocknum));
//output(SudokuEdges);

BlockColors := ['GOLD', 'HOTPINK', 'LIGHTBLUE', 'LIGHTSEAGREEN','MINTCREAM','MISTYROSE', 'INDIANRED', 'LIMEGREEN', 'ORANGERED'];

SudokuNodes := project(NodesPrep, transform(gexf.CreateGraph.graph_node_rec, self.id := left.blocknum, self.label := (string)left.blocknum, 
                                      self.color := BlockColors[left.boxnum]));
//output(SudokuNodes);

SudokuGraph := gexf.CreateGraph.getGraphgexf(SudokuNodes, SudokuEdges);
output(SudokuGraph);

